#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gdbm.h>

#include "ci067.h"
#include "agenda.h"
#include "ihm.h"
#include "disco.h"

main (int argc, char *argv[])
{

  ENDERECO *agenda, *ragenda;
  char arquivo[TAM_ARQNOME];
  int nitens;
  GDBM_FILE dbf;
 
  if (argc < 2)
    do {
      printf("Entre o nome do arquivo da agenda: ");
    } while (cigets(arquivo, sizeof(arquivo), stdin) == NULL || ! strlen(arquivo));
  else if (argc == 2)
    strcpy (arquivo, argv[1]);

  if (argc > 2)
    printf("\nForma de uso: %s [arquivo_agenda]\n\n", argv[0]);
  else {
    dbf = gdbm_open  (arquivo, 512, GDBM_WRCREAT, 0644, 0);
    
    if (dbf == NULL)
      printf("Erro ao criar base de dados %s\n", arquivo);
    else {
      agenda = (ENDERECO *) calloc (0, sizeof(ENDERECO));
      
      nitens = 0;
      do {
	agenda = (ENDERECO *) realloc (agenda,
				       (nitens + 1) * sizeof(ENDERECO));
	if (agenda)
	  agenda[nitens] = leItem();
      } while (agenda && strlen(agenda[nitens++].nome));
      
      /*
	 imprimeAgenda(agenda);
       */

      printf("\n\nGravando agenda na base de dados arquivo \"%s\" .... ", arquivo);
      if (!gravaAgenda(agenda, nitens - 1, dbf))
	printf("Erro na gravacao da agenda !!!!!\n\n");
      else {
	printf("OK!!!!\n\n");
	
	/* Testando gravacao */
	gdbm_close(dbf);
	dbf = gdbm_open  (arquivo, 512, GDBM_READER, 0644, 0);
	
	if (dbf) {
	  printf("\n\nLendo agenda da base de dados \"%s\" ....\n\n ", arquivo);
	  if ((ragenda = leAgenda(nitens - 1, dbf)) != NULL)
	    imprimeAgenda(ragenda);
	}
      }

      gdbm_close(dbf);     /* fecha arquivo */
    }  /* FIM (dbf == NULL) */
  }  /* FIM (argc > 2) */
}
